package org.hso.ecommerce.entities.warehouse;

import org.hso.ecommerce.entities.shop.Article;

import javax.persistence.*;

@Entity
@Table(name = "warehouse_booking_position_entries")
public class WarehouseBookingPositionSlotEntry {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic
    public long id;

    @ManyToOne
    public Article article;

    // Can;t do, does not work when created in action.
    //public int newSumArticles;
    public int newSumSlot;

    public int slot;

    public WarehouseBookingPositionSlotEntry copyAddAmount(int amount) {
        WarehouseBookingPositionSlotEntry e = new WarehouseBookingPositionSlotEntry();

        e.article = article;
        e.slot = slot;

        e.newSumSlot = newSumSlot + amount;

        assert e.article.warehouseUnitsPerSlot >= e.newSumSlot;
        assert e.newSumSlot >= 0;

        return e;
    }
}
